"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.normalizePolygonDirection = normalizePolygonDirection;

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function normalizePolygonDirection(polygon) {
  let xmax = -Infinity;
  let xindex = -1;

  var _arr = Object.entries(polygon);

  for (var _i = 0; _i < _arr.length; _i++) {
    let _arr$_i = _slicedToArray(_arr[_i], 2),
        i = _arr$_i[0],
        _arr$_i$ = _slicedToArray(_arr$_i[1], 1),
        x = _arr$_i$[0];

    if (x > xmax) {
      xmax = x;
      xindex = +i;
    }
  }

  let prev = polygon[(polygon.length + xindex - 1) % polygon.length];
  let next = polygon[(polygon.length + xindex + 1) % polygon.length];
  let clockwise = prev[1] > next[1];

  if (clockwise) {
    return polygon;
  } else {
    return polygon.reverse();
  }
}